# Enum Class CommonCRS.Engineering

Object
Enum<CommonCRS.Engineering>
Engineering

All Implemented Interfaces:
  `Serializable`, `Comparable<CommonCRS​.Engineering>`, `Constable`

Enclosing class:
  `CommonCRS`

public static enum CommonCRS.Engineering extends Enum<CommonCRS.Engineering>
Frequently-used engineering CRS and datum that are guaranteed to be available in SIS. Below is an alphabetical list of object names available in this enumeration:

> Temporal objects accessible by enumeration constants
> Name or alias | Object type | Enumeration value
> --- | --- | ---
> Computer display | CRS, Datum | `GEODISPLAY`
> Computer display | CRS, Datum | `DISPLAY`

Since:
  1.1

- ## Nested Class Summary

  ### Nested classes/interfaces inherited from class Enum

  `Enum​.EnumDesc<E extends Enum<E>>`

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `DISPLAY`
  Cartesian coordinate system with (right, down) oriented axes in pixel units.
  `GEODISPLAY`
  Cartesian coordinate system with (east, south) oriented axes in pixel units.
  `GRID`
  Cartesian coordinate system with (column, row) oriented axes in unity units.
  `TIME`
  A single-dimensional coordinate system for time in seconds since an unknown epoch.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `EngineeringCRS`
  `crs()`
  Returns the coordinate reference system associated to this engineering object.
  `EngineeringDatum`
  `datum()`
  Returns the datum associated to this engineering object.
  `boolean`
  `datumUsedBy(CoordinateReferenceSystem crs)`
  Returns `true` is the given CRS uses the datum identified by this enumeration value.
  `static CommonCRS​.Engineering`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static CommonCRS​.Engineering[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.

  ### Methods inherited from class Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

  ### Methods inherited from class Object

  `getClass, notify, notifyAll, wait, wait, wait`

- ## Enum Constant Details

  - ### GEODISPLAY

    public static final CommonCRS.Engineering GEODISPLAY
    Cartesian coordinate system with (east, south) oriented axes in pixel units. Axis directions are `EAST` and `SOUTH`, which implies that the coordinate system can be related to a geospatial system in some way. The CRS is defined by the OGC Web Map Service Interface specification.

    > Computer display properties
    > WMS identifier: | CRS:1
    > Primary names: | "Computer display"
    > Direction: | `AxisDirection.EAST`, `SOUTH`
    > Unit: | `Units.PIXEL`

  - ### DISPLAY

    public static final CommonCRS.Engineering DISPLAY
    Cartesian coordinate system with (right, down) oriented axes in pixel units. This definition does not require the data to be geospatial.

    > Computer display properties
    > Primary names: | "Computer display"
    > Direction: | `AxisDirection.DISPLAY_RIGHT`, `DISPLAY_DOWN`
    > Unit: | `Units.PIXEL`

  - ### GRID

    public static final CommonCRS.Engineering GRID
    Cartesian coordinate system with (column, row) oriented axes in unity units. This definition does not require the data to be geospatial.

    > Grid properties
    > Primary names: | "Cell indices"
    > Direction: | `AxisDirection.COLUMN_POSITIVE`, `ROW_POSITIVE`
    > Unit: | `Units.UNITY`

  - ### TIME

    public static final CommonCRS.Engineering TIME
    A single-dimensional coordinate system for time in seconds since an unknown epoch. This definition can be used as a fallback when `CommonCRS​.Temporal` enumeration cannot be used, for example because the temporal datum epoch is unknown.

    > Time properties
    > Primary names: | "Time"
    > Direction: | `AxisDirection.FUTURE`
    > Unit: | `Units.SECOND`

    See Also:
      - `CommonCRS​.Temporal`

- ## Method Details

  - ### values

    public static CommonCRS.Engineering[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static CommonCRS.Engineering valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null

  - ### crs

    public EngineeringCRS crs()
    Returns the coordinate reference system associated to this engineering object.
    Returns:
      the CRS associated to this enum.

  - ### datum

    public EngineeringDatum datum()
    Returns the datum associated to this engineering object.
    Returns:
      the datum associated to this enum.

  - ### datumUsedBy

    public boolean datumUsedBy(CoordinateReferenceSystem crs)
    Returns `true` is the given CRS uses the datum identified by this enumeration value. The association may be direct through `SingleCRS​.getDatum()`, or indirect throw at least one of the members of `getDatumEnsemble(SingleCRS)`.
    Parameters:
      `crs` - the CRS to compare against the datum of this enumeration value. May be `null`.
    Returns:
      whether the given CRS uses the datum, directly or indirectly.
    Since:
      1.5